import 'package:flutter/material.dart';

class YFAdsCallBack {
  static const YF_ADS_TYPE_BANNER = "type_banner";
  static const YF_ADS_TYPE_INTERACTION = "type_interaction";
  static const YF_ADS_TYPE_SPLASH = "type_splash";
  static const YF_ADS_TYPE_REWARD_VIDEO = "type_reward_video";
  static const YF_ADS_TYPE_EXPRESS_FEED = "type_express_feed";
  static const YF_ADS_TYPE_DRAW_NATIVE_EXPRESS_VIDEO = "type_draw_native_express_video";
  static const YF_ADS_TYPE_NATIVE_DRAW_FEED_VIDEO = "type_native_draw_feed_video";
  static const YF_ADS_ANDROID_SUCCESS = "onAdSuccess";

  final String? method;

  final String? error;

  final String? viewId;

  final String? adType;

  final String? ecpm;

  const YFAdsCallBack(
      {@required this.method, this.error, this.viewId, @required this.adType, this.ecpm});

  YFAdsCallBack.fromJson(Map<String, dynamic> json)
      : method = json['method'],
        error = json['error'],
        viewId = json['view_id'],
        adType = json['ad_type'],
        ecpm = json['ecpm'];

  Map<String, dynamic> toJson() => {
        'method': method,
        'error': error,
        'view_id': viewId,
        'ad_type': adType,
        'ecpm': ecpm,
      };
}
